local wezterm = require("wezterm") --[[@as Wezterm]]

local config = {}

-- color scheme
config.color_scheme = "Everforest Dark Soft (Gogh)"
-- font
config.font = wezterm.font("Hack")
config.font_size = 14.0
-- Ligatures in terminal/programming fonts IMO are a bad idea,
-- as they require the user to mentally translate what the ligature represents,
-- and in some cases, they misrepresent code semantics due to ligature substitution
-- being a dumb search/replace regardless of the context.
-- != isn't the not equal to operator in Lua for instance (that would be ~=),
-- but ligature fonts will render it as ≠ regardless, even in a string literal.
-- Even worse, some fonts also render <= and =< both as ≤, since there are languages
-- that use one or the other, even though only one is correct for any given language,
-- causing unnecessary ambiguity.
-- It's not a big deal, ultimately, but disabling ligatures avoids the above problems.
config.harfbuzz_features = { "calt=0", "clig=0", "liga=0" }
-- tab bar
config.show_new_tab_button_in_tab_bar = false
config.use_fancy_tab_bar = false
-- graphics
config.front_end = "WebGpu"
-- inactive panes
config.inactive_pane_hsb = {
    saturation = 0.9,
    brightness = 0.5
}
-- scrollbar
config.enable_scroll_bar = true

-- cursor
config.default_cursor_style = 'SteadyBar'

return config
